"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  YouVisitIWC: () => YouVisitIWC,
  hello: () => hello
});
module.exports = __toCommonJS(index_exports);

// src/YouVisitIWC/YouVisitIWC.tsx
var import_react3 = require("react");

// src/YouVisitIWC/config.ts
var YV_SOURCE = "https://www.youvisit.com/tour/Embed/js3";
var DEFAULT_DESCRIPTION = "Interactive Image Element";
var DEFAULT_UPLOAD_DATE = "2020-03-31T08:00:00+08:00";
var PUBLISHER_CONFIG = {
  name: "EAB",
  logo: {
    url: "https://attachment.eab.com/wp-content/uploads/2019/07/EAB-Logo-RGB.png",
    width: 500,
    height: 193
  }
};

// src/YouVisitIWC/components/JsonLd.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var JsonLd = ({ data }) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
  "script",
  {
    type: "application/ld+json",
    dangerouslySetInnerHTML: { __html: JSON.stringify(data) }
  }
);
var JsonLd_default = JsonLd;

// src/YouVisitIWC/utils.ts
var generateJsonLdData = (title, description, thumb, uploadDate) => ({
  "@context": "https://schema.org",
  "@type": "VideoObject",
  name: title,
  description,
  thumbnailUrl: thumb,
  uploadDate,
  publisher: {
    "@type": "Organization",
    name: PUBLISHER_CONFIG.name,
    logo: {
      "@type": "ImageObject",
      ...PUBLISHER_CONFIG.logo
    }
  },
  contentUrl: "url of actual tour",
  embedUrl: "url where the tour has been placed",
  interactionCount: "locations.views"
});
var generateAnchorProps = (props) => {
  const baseProps = {
    href: "https://www.youvisit.com",
    title: props.title,
    "data-inst": props.institution,
    "data-link-type": props.linkType,
    "data-loc": props.location,
    "data-platform": "v",
    "data-type": props.type,
    "data-hover-width": props.hoverWidth,
    "data-hover-height": props.hoverHeight,
    "data-image-width": props.iwcWidth,
    "data-image-height": props.iwcHeight
  };
  if (props.stopId) {
    baseProps["data-stopid"] = props.stopId;
  }
  if (props.type !== "hover-panel") {
    baseProps["data-type"] = props.type;
  }
  return baseProps;
};
var generateDataAttributesString = (anchorProps) => {
  const entries = Object.entries(anchorProps).filter(
    ([key]) => key.startsWith("data-")
  );
  return entries.map(
    ([key, value], index) => `    ${index === 0 ? "?" : "&"}${key}=${value}`
  ).join("\n");
};

// src/hooks/useScript.ts
var import_react = require("react");
function useScript(src, options = {}) {
  const [status, setStatus] = (0, import_react.useState)("loading");
  const optionsRef = (0, import_react.useRef)(options);
  (0, import_react.useEffect)(() => {
    let script = document.querySelector(
      `script[src="${src}"]`
    );
    if (script) {
      const domStatus = script.getAttribute("data-status");
      if (domStatus) {
        setStatus(domStatus);
        return;
      }
      script.setAttribute("data-status", "ready");
      setStatus("ready");
      return;
    }
    script = document.createElement("script");
    script.src = src;
    script.async = true;
    script.setAttribute("data-status", "loading");
    document.body.appendChild(script);
    const handleScriptLoad = () => {
      script.setAttribute("data-status", "ready");
      setStatus("ready");
      removeEventListeners();
    };
    const handleScriptError = () => {
      script.setAttribute("data-status", "error");
      setStatus("error");
      removeEventListeners();
    };
    const removeEventListeners = () => {
      script.removeEventListener("load", handleScriptLoad);
      script.removeEventListener("error", handleScriptError);
    };
    script.addEventListener("load", handleScriptLoad);
    script.addEventListener("error", handleScriptError);
    const removeOnUnmount = optionsRef.current.removeOnUnmount;
    return () => {
      if (removeOnUnmount === true) {
        script.remove();
        removeEventListeners();
      }
    };
  }, [src]);
  return status;
}

// src/YouVisitIWC/YouVisitIWC.tsx
var import_react_syntax_highlighter = require("react-syntax-highlighter");
var import_markup = __toESM(require("react-syntax-highlighter/dist/cjs/languages/prism/markup"), 1);
var import_prism = require("react-syntax-highlighter/dist/cjs/styles/prism");

// src/YouVisitIWC/components/copy-to-clipboard.tsx
var import_react2 = require("react");

// src/YouVisitIWC/YouVisitIWC.module.css
var YouVisitIWC_default = {};

// src/YouVisitIWC/components/copy-to-clipboard.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var CopyToClipboard = ({
  textData,
  buttonTextPreCopy = "Copy to clipboard",
  buttonTextPostCopy = "Copied!"
}) => {
  const [copied, setCopied] = (0, import_react2.useState)(false);
  const copyToClipboard = async () => {
    if (navigator.clipboard) {
      try {
        await navigator.clipboard.writeText(textData);
        setCopied(true);
      } catch (err) {
        console.error("Failed to copy with Clipboard API:", err);
        fallbackCopyToClipboard();
      }
    } else {
      fallbackCopyToClipboard();
    }
    setTimeout(() => {
      setCopied(false);
    }, 500);
  };
  const fallbackCopyToClipboard = () => {
    try {
      const textArea = document.createElement("textarea");
      textArea.value = textData;
      textArea.style.top = "0";
      textArea.style.left = "0";
      textArea.style.position = "fixed";
      textArea.style.opacity = "0";
      document.body.appendChild(textArea);
      textArea.focus();
      textArea.select();
      const successful = document.execCommand("copy");
      document.body.removeChild(textArea);
      if (successful) {
        setCopied(true);
      } else {
        console.error("Fallback clipboard copy failed");
      }
    } catch (err) {
      console.error("Fallback clipboard copy error:", err);
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: YouVisitIWC_default.container, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("button", { onClick: copyToClipboard, className: YouVisitIWC_default.button, children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: copied ? buttonTextPostCopy : buttonTextPreCopy }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        fill: "none",
        viewBox: "0 0 24 24",
        strokeWidth: "1.5",
        stroke: "currentColor",
        className: `${YouVisitIWC_default.icon} ${copied ? YouVisitIWC_default.iconSuccess : ""}`,
        children: copied ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "path",
          {
            strokeLinecap: "round",
            strokeLinejoin: "round",
            d: "M11.35 3.836c-.065.21-.1.433-.1.664 0 .414.336.75.75.75h4.5a.75.75 0 00.75-.75 2.25 2.25 0 00-.1-.664m-5.8 0A2.251 2.251 0 0113.5 2.25H15c1.012 0 1.867.668 2.15 1.586m-5.8 0c-.376.023-.75.05-1.124.08C9.095 4.01 8.25 4.973 8.25 6.108V8.25m8.9-4.414c.376.023.75.05 1.124.08 1.131.094 1.976 1.057 1.976 2.192V16.5A2.25 2.25 0 0118 18.75h-2.25m-7.5-10.5H4.875c-.621 0-1.125.504-1.125 1.125v11.25c0 .621.504 1.125 1.125 1.125h9.75c.621 0 1.125-.504 1.125-1.125V18.75m-7.5-10.5h6.375c.621 0 1.125.504 1.125 1.125v9.375m-8.25-3l1.5 1.5 3-3.75"
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "path",
          {
            strokeLinecap: "round",
            strokeLinejoin: "round",
            d: "M15.75 17.25v3.375c0 .621-.504 1.125-1.125 1.125h-9.75a1.125 1.125 0 01-1.125-1.125V7.875c0-.621.504-1.125 1.125-1.125H6.75a9.06 9.06 0 011.5.124m7.5 10.376h3.375c.621 0 1.125-.504 1.125-1.125V11.25c0-4.46-3.243-8.161-7.5-8.876a9.06 9.06 0 00-1.5-.124H9.375c-.621 0-1.125.504-1.125 1.125v3.5m7.5 10.375H9.375a1.125 1.125 0 01-1.125-1.125v-9.25m12 6.625v-1.875a3.375 3.375 0 00-3.375-3.375h-1.5a1.125 1.125 0 01-1.125-1.125v-1.5a3.375 3.375 0 00-3.375-3.375H9.75"
          }
        )
      }
    )
  ] }) });
};
var copy_to_clipboard_default = CopyToClipboard;

// src/YouVisitIWC/YouVisitIWC.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
import_react_syntax_highlighter.PrismLight.registerLanguage("html", import_markup.default);
var YouVisitIWC = ({
  containerHeight = "300px",
  containerWidth = "100%",
  title = "Launch Experience",
  description = DEFAULT_DESCRIPTION,
  thumb,
  uploadDate = DEFAULT_UPLOAD_DATE,
  institution = 0,
  linkType = "immersive",
  location = 0,
  type = "inline-embed",
  stopId,
  hoverWidth = "90%",
  hoverHeight = "70%",
  iwcWidth = "100%",
  iwcHeight = "100%",
  showCode
}) => {
  const [isReady, setIsReady] = (0, import_react3.useState)(false);
  const jsonLdData = generateJsonLdData(title, description, thumb, uploadDate);
  const status = useScript(YV_SOURCE, {
    removeOnUnmount: false
  });
  (0, import_react3.useEffect)(() => {
    if (status === "ready" && typeof window !== "undefined" && window.YVScript) {
      window.YVScript.scanEmbeds();
      setIsReady(true);
    }
  }, [status]);
  const anchorProps = generateAnchorProps({
    title,
    institution,
    linkType,
    location,
    type,
    stopId,
    hoverWidth,
    hoverHeight,
    iwcWidth,
    iwcHeight
  });
  const dataAttributesString = generateDataAttributesString(anchorProps);
  const codeString = `<div style="height: ${containerHeight}; width: ${containerWidth}">
  <a alt="Launch Experience" href="https://www.youvisit.com/#/vte/
${dataAttributesString}">
    Virtual Tour
  </a>
</div>`;
  const codeString2 = `<script async="async" defer="defer" src="${YV_SOURCE}"></script>`;
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(import_jsx_runtime3.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
      "div",
      {
        className: `${YouVisitIWC_default.codeSnippetContainer}${isReady ? " ready" : ""}`,
        style: { width: containerWidth, height: containerHeight },
        children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("a", { className: "virtualtour_embed", ...anchorProps, children: "Virtual Tour" })
      }
    ),
    showCode && /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(import_jsx_runtime3.Fragment, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("h3", { children: "Place the HTML below anywhere on your page to display your IWC:" }),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: YouVisitIWC_default.codeSnippetContainer, children: [
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: YouVisitIWC_default.copyButtonContainer, children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(copy_to_clipboard_default, { textData: codeString }) }),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          import_react_syntax_highlighter.PrismLight,
          {
            language: "html",
            style: import_prism.coldarkCold,
            customStyle: {
              margin: "1rem 0",
              borderRadius: "4px",
              background: "#f5f5f5"
            },
            wrapLines: true,
            wrapLongLines: true,
            children: codeString.trim()
          }
        )
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("h3", { children: "Place the script below anywhere on the same page as HTML above:" }),
      /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: YouVisitIWC_default.codeSnippetContainer, children: [
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: YouVisitIWC_default.copyButtonContainer, children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(copy_to_clipboard_default, { textData: codeString2 }) }),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          import_react_syntax_highlighter.PrismLight,
          {
            language: "html",
            style: import_prism.coldarkCold,
            customStyle: {
              margin: "1rem 0",
              borderRadius: "4px",
              background: "#f5f5f5"
            },
            wrapLines: true,
            wrapLongLines: true,
            children: codeString2.trim()
          }
        )
      ] })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(JsonLd_default, { data: jsonLdData })
  ] });
};

// src/index.ts
var hello = () => {
  console.log("Hello from YouVisitIWC!");
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  YouVisitIWC,
  hello
});
//# sourceMappingURL=index.cjs.map